/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

/**
 * A vertical 3d square defined by 2 points.
 */

import java.awt.*;

public class Square extends Polygon3d
{
	public Square(Vertex p1, Vertex p2)
	{
		this(p1, p2, null);
			//{{INIT_CONTROLS
		//}}
}

	public Square(Vertex p1, Vertex p2, Texture texture)
	{
		super();
		Vertex a  = new Vertex();
		Vertex b  = new Vertex();
		double l, nx, ny, nz;
		Polygon3d t = new Polygon3d();

		this.texture = texture;

		if (p1.y != p2.y)
		{
			this.p[0] = new Vertex(p2.x, p2.y, p2.z, p1.u, p2.v);
			this.p[1] = new Vertex(p2.x, p1.y, p2.z, p1.u, p1.v);
			this.p[2] = new Vertex(p1.x, p1.y, p1.z, p2.u, p1.v);
			this.p[3] = new Vertex(p1.x, p2.y, p1.z, p2.u, p2.v);

			a.x = 0;
			a.y = p2.y - p1.y;
			a.z = 0;

			b.x = p2.x - p1.x;
			b.y = 0;
			b.z = p2.z - p1.z;

			nx = (b.z * a.y);
			ny = 0;
			nz = -(a.y * b.x);
		}
		else
		{
			this.p[0] = new Vertex(p2);
			this.p[1] = new Vertex(p2.x, p1.y, p1.z, p1.u, p2.v);
			this.p[2] = new Vertex(p1);
			this.p[3] = new Vertex(p1.x, p2.y, p2.z, p2.u, p1.v);

			nx = 0;
			ny = -1;
			nz = 0;
		}

		this.middle = new Vertex(
						(p1.x + p2.x) / 2,
						(p1.y + p2.y) / 2,
						(p1.z + p2.z) / 2,
						(p1.u + p2.u) / 2,
						(p1.v + p2.v) / 2
					);

		l = Math.sqrt((nx * nx) + (ny * ny) + (nz * nz));

		this.normal.x = nx / l;
		this.normal.y = ny / l;
		this.normal.z = nz / l;

		this.col = new Color(0, 0, 255);

		this.vertcount = 4;
	}
	//{{DECLARE_CONTROLS
	//}}
}
