/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;
/**
    Texture. 
    Une image sous forme de tableau de pixels
    Eventuellement tiled
 */

import java.awt.*;
import java.awt.image.*;


public class Texture 
{
	Image theImage;
	int texels[];
	int	iWidth;
	int	iHeight;
	int	tWidth;
	int	tHeight;
	Color baseColour;
	double ambient = 2 / 10;


	public Texture(Color baseColour) 
	{
		this.baseColour = baseColour;
		tHeight = tWidth = 1;
			//{{INIT_CONTROLS
		//}}
}	

	public Texture(Color baseColour, double ambient) 
	{
		this(baseColour);
		this.ambient = ambient;
	}	


 public Texture(Image img, int multx, int multy) 
  {
	iWidth  = img.getWidth(null);
	iHeight = img.getHeight(null);

	tWidth  = iWidth  * multx;
	tHeight = iHeight * multy;

	this.theImage = img;

	texels = new int[iWidth* iHeight];
		
	PixelGrabber pixelGrabber = 
	  new PixelGrabber(this.theImage.getSource(),
		0, 0, iWidth, iHeight, texels, 0, iWidth);

	try { pixelGrabber.grabPixels(); }
	catch(Exception e) { e.printStackTrace(); }

  }	


   public Texture(Image theImage) { this(theImage, 1, 1);}	
	

   public Image getImage()
   {

    PaletteShaded palette = new PaletteShaded();    
    Toolkit toolkit = Toolkit.getDefaultToolkit();
    
    MemoryImageSource  mis = new MemoryImageSource(
     iWidth, iHeight, 
     palette.getColorModel(), texels, 0, iWidth);

    return toolkit.createImage(mis);
   } 

 	//{{DECLARE_CONTROLS
	//}}
}
