/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package comgr;

import java.awt.*;
import java.awt.event.*;

/**
    Affiche une palette
*/


public class PalDisp extends Frame
{

 //PanelPalette pp = new PanelPalette();
 Panel panel;
 Graphics g;
 static PaletteShaded palette = new PaletteShaded();
// static Palette palette = new Palette();
// static PalettePastel palette = new PalettePastel();
// static PalettePlasma palette = new PalettePlasma();

 MenuBar menuBar = new MenuBar();
 Menu menuFile = new Menu();
 MenuItem menuFileExit = new MenuItem();
 Menu menuHelp = new Menu();
 MenuItem menuHelpAbout = new MenuItem();


 public PalDisp()
  {
   setSize(640, 480);
   setLayout(new BorderLayout());
   setTitle(" Palette display");

   Font mf = new Font("Dialog", Font.PLAIN, 14);
   Action aListener = new Action();

   menuFile.setLabel("File");
   menuFile.setFont(mf);
   menuBar.add(menuFile);

   menuFileExit.setLabel("Exit");
   menuFileExit.addActionListener(aListener);
   menuFileExit.setFont(mf);
   menuFile.add(menuFileExit);

   menuHelp.setLabel("Help");
   menuHelp.setFont(mf);
   menuHelp.add(menuHelp);
   menuBar.add(menuHelp);

   menuHelpAbout.setLabel("About");
   menuHelpAbout.addActionListener(aListener);
   menuHelpAbout.setFont(mf);
   menuHelp.add(menuHelpAbout);

   this.setMenuBar(menuBar);


   panel = new Panel();
   add(panel, BorderLayout.CENTER);

   palette.fill();

   SymWindow aSymWindow = new SymWindow();
   this.addWindowListener(aSymWindow);

 }




 public void paint(Graphics g)
 {

  g = panel.getGraphics();

  Dimension size = panel.getSize();
  int w = size.width;
  int h = size.height;


  palette.display(g, 0, 0, w, h);

  /*
  for(int i = 0; i < 48; i++)
  {
   g.setColor(palette.getColor(i));
   g.fillRect(60 + i * 20, 60 + i * 20, 20, 20);
  }
  */
 }


 static public void main(String args[])
 {
   (new PalDisp()).show();

 }



 class SymWindow extends  java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == PalDisp.this) System.exit(0);
		}
	}


 class Action implements java.awt.event.ActionListener
	{
	  public void actionPerformed(java.awt.event.ActionEvent event)
	   {
		 Object object = event.getSource();

		 if (object == menuFileExit) 		       { System.exit(0); }
  	 else if (object == menuHelpAbout)		 { }
     }
  } // action


}
