/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package comgr;

import java.awt.*;
import java.awt.event.*;



public class PaletteMaker extends Windows implements ActionListener, ComponentListener
{

  Color UserColor;
  int Red;
  int Green;
  int Blue;

	// Setup pal
  Panel panelSetupUser;
  Label labelPalTitle;
  DSign panelPal;
  DSign panelUserColor;
  HSlider UR;
  HSlider UG;
  HSlider UB;
  Label labelUR;
  Label labelUG;
  Label labelUB;

        // Setup palette

  public PaletteMaker()
  {
    super("Palette Maker", true);

		panelSetupUser = new java.awt.Panel();
		panelSetupUser.setLayout(null);
		panelSetupUser.setBounds(12,33,574,258);
		panelSetupUser.setBackground(PrgColor);
		tabSetup.add(panelSetupUser);

		labelPalTitle = new Label("Creating the User color");
		labelPalTitle.setBounds(80, 16, 240, 20);
		labelPalTitle.setFont(new Font("Dialog", Font.BOLD, 14));
		//labelPalTitle.setBackground(PrgColor);
		panelSetupUser.add(labelPalTitle);

		panelUserColor = new DSign();
		panelUserColor.setBounds(464, 76, 64, 64);
		panelUserColor.setBevel(DSign.RAISED);
		panelUserColor.setBackground(Preferences.UserColor);
		panelSetupUser.add(panelUserColor);

		// Setup pal

		UR = new HSlider(128, 62);
		UR.setBackground(Color.red);
		panelSetupUser.add(UR);
        UR.setValue(Red);

		labelUR = new Label(Integer.toString(Red),Label.CENTER);
		labelUR.setBounds(80, 62, 32, 20);
		labelUR.setBackground(Color.black);
		labelUR.setForeground(Color.green);
		panelSetupUser.add(labelUR);

		UG = new HSlider(128, 96);
	    UG.setBackground(Color.green.darker());
		panelSetupUser.add(UG);
        UG.setValue(Green);

		labelUG = new Label(Integer.toString(Green),Label.CENTER);
		labelUG.setBounds(80, 96, 32, 20);
		labelUG.setBackground(Color.black);
		labelUG.setForeground(Color.green);
		panelSetupUser.add(labelUG);

		UB = new HSlider(128, 128);
		UB.setBackground(Color.blue);
		panelSetupUser.add(UB);
        UB.setValue(Blue);

		labelUB = new Label(Integer.toString(Blue),Label.CENTER);
		labelUB.setBounds(80, 128, 32, 20);
		labelUB.setBackground(Color.black);
		labelUB.setForeground(Color.green);
		panelSetupUser.add(labelUB);


        UR.addActionListener(this);
        UG.addActionListener(this);
        UB.addActionListener(this);


		panelSetupUser.addComponentListener(this);
  }


 // Redfinition de la couleur "User" selon prfrence ou sliders
 void getUserRGB()
 {
   int rgb = Preferences.UserColor.getRGB();

   Red =  ((rgb >> 16) & 255);
   Green =  ((rgb >> 8) & 255);
   Blue =  (rgb & 255);
 }

 void getUserColor()
 {
    int index = ColorList.getIndex("User");

    Red   = ColorList.getRed(index); //Preferences.UserColor.getRed();
    Green = ColorList.getGreen(index); //Preferences.UserColor.getGreen();
    Blue  = ColorList.getBlue(index); //Preferences.UserColor.getBlue();
 }


 void setUserColor()
  {
   UserColor =  new Color(Red, Green, Blue);
   ColorList.changeColor("User", UserColor);
  }

 void SetupUser_componentShown()
 {

 }

	  public void actionPerformed(java.awt.event.ActionEvent event)
	   {
		 Object object = event.getSource();


		 if(object == UR)
		  {
		     Red = UR.getValue();
		     setUserColor();
		     labelUR.setText(Integer.toString(Red));
		     panelUserColor.setBackground(Preferences.UserColor);
		 }
 		 else if(object == UG)
 		   {
 		     Green = UG.getValue();
 		     setUserColor();
		     labelUG.setText(Integer.toString(Green));
		     panelUserColor.setBackground(Preferences.UserColor);
 		   }
		 else if(object == UB)
		   {
		     Blue = UB.getValue();
		     setUserColor();
		     labelUB.setText(Integer.toString(Blue));
		     panelUserColor.setBackground(Preferences.UserColor);
		   }
       }
       
    // Gestion d'vnement d'affichage des paneaux

	 
	  public void componentResized(java.awt.event.ComponentEvent event)
	  {
	  /*
	   Object object = event.getSource();
	   if (object == panelImage) imageMessage();
	  */
	     ;
	  }
	  
      public void componentShown(java.awt.event.ComponentEvent event)
	   {
          ;		
       }


      public void componentHidden(java.awt.event.ComponentEvent event)
	   {
          ;
	   }

      public void componentMoved(java.awt.event.ComponentEvent event)
	   {
          ;
	   }

  }



