/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package comgr;

import java.awt.*;
import java.awt.image.*;


/**
   Fonctionnnement

   - Le tableau hrit "screen" contient le tableau agrandi
   - Il est remplit  partir de l'cran virtuel de base
     associ affect  "real"
*/

public class VirtualBig extends VirtualDirect
{
 int SQUARE = 3;

 VirtualDirect real;  // tableau de rfrence

 /**
    On construit un cran virtuel gant,
    avec tableau et dimension comme un cran normal
    mais avec un cran de base en plus
 */

 public VirtualBig(VirtualDirect vd)
 {
  super();
  real = vd;
 		//{{INIT_CONTROLS
		//}}
}

 public VirtualBig(VirtualDirect vd, int w, int h)
  {
   this(vd);
   setSize(w, h);
  }

 public VirtualBig(VirtualDirect vd, int [] iArray, int w, int h)
  {
   super(iArray, w, h);
   real = vd;
  }

 /** Ce constructeur pour faire un clone (n'utilise pas update) */
 public VirtualBig(int w, int h)
 {
  real = null;
  super.setSize(w, h);
 }

 public void setSize(VirtualDirect vd, int w, int h)
 {
   super.setSize(w, h);
   real = vd;
 }

 /**
    On change l'cran virtuel de base
    Les donnes y seront lues par update();
    setSize va crer le tableau
 */
 public void setBase(VirtualDirect vd)
  {
   setSize(vd, vd.width * SQUARE, vd.height * SQUARE);
  }


 public void setSquare(int square)
 {
  switch(square)
  {
   case 5:   SQUARE = 5;
             break;
   case 7:   SQUARE = 7;
             break;
   default:  SQUARE = 3;
             break;
  }
 }

  /**
     Dfinit la taille d'un tile
     Pour plus tard
  */

  /*
  public void magnify(int w, int h)
  {
    try
    {
     int hfactor = w / WIDTH;
     int vfactor = h / HEIGHT;
     SQUARE = (hfactor > vfactor) ? vfactor : hfactor;
    }
    catch(Exception e) { System.out.println("Painter - " + e.toString()); }

  }

  public void magnify()
  {
    Dimension size = getSize(); // Taille canvas
    int w = size.width;
    int h = size.height;

    magnify(w, h);
  }
*/


 /**
     pixel
     Coordonnes en real
 */

 public void pixel(int x, int y, int color)
 {
  COLOR = color;
  pixel(x, y);
 }


 public void pixel(int x, int y)
 {
  y = real.height - y - 1;

  if(x < 0) return;
  if(x >= width) return;
  if(y < 0) return;
  if(y >= height) return;


  switch(SQUARE)
  {
   case  5:  set5(x, y); break;
   case  7:  set7(x, y); break;
   default:  set3(x, y); break;
  }
 }

 public void set3(int x, int y)
 {
  int yo = y;
  y = y * width * 3;
  x *= 3;

  try
  {
   screen[y + x] = COLOR;
   screen[y + x + 1] = COLOR;
   screen[y + x + 2] = COLOR;

   y += width;
   screen[y + x] = COLOR;
   screen[y + x + 1] = COLOR;
   screen[y + x + 2] = COLOR;

   y += width;
   screen[y + x] = COLOR;
   screen[y + x + 1] = COLOR;
   screen[y + x + 2] = COLOR;

  }
  catch(ArrayIndexOutOfBoundsException e)
  {
    int index = y + x;
    error("Error Pixelx3 - x:" +
      x + "/" + width + " y:" + (yo * 3)  + "/" + height + " Index: " + index + "/" + screen.length);
  }
 }

 public void set5(int x, int y)
 {
  y = y * width * 5;
  x *= 5;

  try
  {
   screen[y + x] = COLOR;
   screen[y + x + 1] = COLOR;
   screen[y + x + 2] = COLOR;
   screen[y + x + 3] = COLOR;
   screen[y + x + 4] = COLOR;
   y += width;
   screen[y + x] = COLOR;
   screen[y + x + 1] = COLOR;
   screen[y + x + 2] = COLOR;
   screen[y + x + 3] = COLOR;
   screen[y + x + 4] = COLOR;
   y += width;
   screen[y + x] = COLOR;
   screen[y + x + 1] = COLOR;
   screen[y + x + 2] = COLOR;
   screen[y + x + 3] = COLOR;
   screen[y + x + 4] = COLOR;
   y += width;
   screen[y + x] = COLOR;
   screen[y + x + 1] = COLOR;
   screen[y + x + 2] = COLOR;
   screen[y + x + 3] = COLOR;
   screen[y + x + 4] = COLOR;
   y += width;
   screen[y + x] = COLOR;
   screen[y + x + 1] = COLOR;
   screen[y + x + 2] = COLOR;
   screen[y + x + 3] = COLOR;
   screen[y + x + 4] = COLOR;
  }
  catch(ArrayIndexOutOfBoundsException e)
  {
    int index = y + x;
    error("Error Pixelx5 - x:" +
      x + "/" + width + " y:" + y / (width) + "/" + height + " Index: " + index + "/" + screen.length);
  }
 }

 public void set7(int x, int y)
 {
  y = y * width * 7;
  x *= 7;

  try
  {
   screen[y + x] = COLOR;
   screen[y + x + 1] = COLOR;
   screen[y + x + 2] = COLOR;
   screen[y + x + 3] = COLOR;
   screen[y + x + 4] = COLOR;
   screen[y + x + 5] = COLOR;
   screen[y + x + 6] = COLOR;

   y += width;
   screen[y + x] = COLOR;
   screen[y + x + 1] = COLOR;
   screen[y + x + 2] = COLOR;
   screen[y + x + 3] = COLOR;
   screen[y + x + 4] = COLOR;
   screen[y + x + 5] = COLOR;
   screen[y + x + 6] = COLOR;

   y += width;
   screen[y + x] = COLOR;
   screen[y + x + 1] = COLOR;
   screen[y + x + 2] = COLOR;
   screen[y + x + 3] = COLOR;
   screen[y + x + 4] = COLOR;
   screen[y + x + 5] = COLOR;
   screen[y + x + 6] = COLOR;

   y += width;
   screen[y + x] = COLOR;
   screen[y + x + 1] = COLOR;
   screen[y + x + 2] = COLOR;
   screen[y + x + 3] = COLOR;
   screen[y + x + 4] = COLOR;
   screen[y + x + 5] = COLOR;
   screen[y + x + 6] = COLOR;
   y += width;
   screen[y + x] = COLOR;
   screen[y + x + 1] = COLOR;
   screen[y + x + 2] = COLOR;
   screen[y + x + 3] = COLOR;
   screen[y + x + 4] = COLOR;
   screen[y + x + 5] = COLOR;
   screen[y + x + 6] = COLOR;
   y += width;
   screen[y + x] = COLOR;
   screen[y + x + 1] = COLOR;
   screen[y + x + 2] = COLOR;
   screen[y + x + 3] = COLOR;
   screen[y + x + 4] = COLOR;
   screen[y + x + 5] = COLOR;
   screen[y + x + 6] = COLOR;
   y += width;
   screen[y + x] = COLOR;
   screen[y + x + 1] = COLOR;
   screen[y + x + 2] = COLOR;
   screen[y + x + 3] = COLOR;
   screen[y + x + 4] = COLOR;
   screen[y + x + 5] = COLOR;
   screen[y + x + 6] = COLOR;

  }
  catch(ArrayIndexOutOfBoundsException e)
  {
    int index = y + x;
    error("Error Pixelx7 - x:" +
      x + "/" + width + " y:" + y / (width) + "/" + height + " Index: " + index + "/" + screen.length);
  }
 }



 public void update(int x, int y)
 {
   pixel(x, y, real.getPixel(x, y));
 }


 /** Cre l'image agrandie */

 public void update()
 {
   int x, y;

   if(screen == null)
   { error("VirtualBig update - screen null"); return; }

   if(real == null)
   {
     error("VirtualBig update - real null " + real.width +"x"+ real.height);
     return;
   }

   int w = real.width;
   int h = real.height;

   if(SQUARE == 3)
   {
    for(y = 0; y < h; y++)
    for(x = 0; x < w; x++)
    {
      COLOR = real.screen[y * w + x];
      set3(x, y);
    }
   }
   else
   if(SQUARE == 5)
   {
    for(y = 0; y < h; y++)
    for(x = 0; x < w; x++)
    {
      COLOR = real.screen[y * w + x];
      set5(x, y);
    }
   }
   else
   {
    for(y = 0; y < h; y++)
    for(x = 0; x < w; x++)
    {
      COLOR = real.screen[y * w + x];
      set7(x, y);
    }
   }


 }


 /**
     Contrairement  la fonction copy de VirtualScreen
     ici on copie directement le tableau,
     car la taille du clone
     est comme celle de l'original
 */
 public void copy(VirtualBig clone)
 {
   int size = width * height;

   for(int i = 0; i < size; i++)
    clone.screen[i] = screen[i];

 }

	//{{DECLARE_CONTROLS
	//}}
} // class
