/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.lang.*;
import java.io.*;


/**
   Cette classe efface l'objet "File" en paramtre
   qui est un fichier ou une arborescence
*/

public final class Deleter
{
    public static String message = null;

    /** Constructeur */
    Deleter() {	} ;

    /** Efface une arborescence - Param nom */

    public static int deleteDir(String path)
    {
      return deleteDir(new File(path));
    }

    /** Efface une arborescence - param File */

    public static int deleteDir(File dirtodel)
    {
     String dlist[] = dirtodel.list();
     int counter = 0;

     //Disp.it("deleter, dirtodel=" + dirtodel);

     for(int i = 0; i < dlist.length; i++)
     {
      File ftodel = new File(dirtodel, dlist[i]);

      if(ftodel.isDirectory())
        counter += deleteDir(ftodel); // Appel rcursif sur contenu
      else
       try { if(ftodel.delete()) counter++; }       // Efface le fichier ou rpertoire lui-mme
       catch(SecurityException e) { message = e.toString(); };
     }  // for

     try { if(dirtodel.delete()) counter++; }       // Efface le rpertoire lui-mme
     catch(SecurityException e) { message = e.toString();};

     return counter;
   } // delete  dir



  /** Efface aprs demande ou non selon prfrences */

  static public int conditional(java.awt.Frame frame, String curdir, String fic)
  {
     File fichier = new File(curdir, fic);
     //boolean ok = true;
     int counter = 0;

     //Disp.it("enter conditional " + curdir + " " + fic);

     if(fichier.isDirectory())  // Effacer un rpertoire
      {
       if(Preferences.AskDeleteDir)
        if(!Directory.IsEmpty(fichier))
        {
         DialogCYN cfd = new DialogCYN(frame, "Delete the directory " + fic + " ?");
         cfd.setVisible(true);
         if(cfd.answer != cfd.YES) return -1;
        }
       counter += deleteDir(fichier);
      } // is directory
     else
      {
       if(Preferences.AskDeleteFile)
        {
         DialogCYN cfd = new DialogCYN(frame, "Delete the file " + fic + " ?");
         cfd.setVisible(true);
         if(cfd.answer != cfd.YES) return -1;
        }
       try {
        boolean res = fichier.delete();
        //Disp.it("delete=" + fichier.getPath() + " " + fichier.getName() + " "  + res);
        if(res) counter++;
        else message = fic + " not deleted";
       }
       catch(SecurityException e) { message = e.toString(); };
      }

      return counter;
    }


  static boolean delete(File f)
  {
    return f.delete();
  }

  static boolean delete(String full)
  {
    String dir = Path.splitPath(full);
    String fic = Path.splitFile(full);
    return (new File(dir, fic)).delete();
  }


};
