/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;

public class DialogYN extends KeyDialog implements ActionListener
{

	java.awt.Button buttonNo;
	java.awt.Button buttonYes;
	java.awt.Label labelConfirm;

	public static final boolean NO = false;
	public static final boolean YES = true;

    DialogKey dialogKey = new DialogKey();

	public DialogYN(Frame parent, String message)
	{
		super(parent, true);
        setSize(getInsets().left + getInsets().right + 384,getInsets().top + getInsets().bottom + 108);

        Color b = parent.getBackground();

		buttonNo = new java.awt.Button("No");
		buttonNo.setBounds(16, 66, 96, 26);
		buttonNo.setBackground(b);
		buttonNo.addActionListener(this);
		panel.add(buttonNo);

		buttonYes = new java.awt.Button("Yes");
		buttonYes.setBounds(272, 66, 96, 26);
		buttonYes.setBackground(b);
		buttonYes.addActionListener(this);
		panel.add(buttonYes);

		labelConfirm = new java.awt.Label("");
		labelConfirm.setBounds(22, 20, 378,30);
		labelConfirm.setFont(new Font("Dialog", Font.PLAIN, 16));
		panel.add(labelConfirm);

		setTitle("Warning");
        labelConfirm.setText(message);
        choice = NO;

		panel.addKeyListener(dialogKey);
		buttonNo.addKeyListener(dialogKey);
		buttonYes.addKeyListener(dialogKey);




}

    /** Surcharge pour Y/N */
    class DialogKey extends java.awt.event.KeyAdapter
	{
		public void keyPressed(java.awt.event.KeyEvent event)
		 {
            if(event.isControlDown() || event.isAltDown())
            {
             return;
            }

            switch(event.getKeyCode())
            {
             case java.awt.event.KeyEvent.VK_Y:
                 case java.awt.event.KeyEvent.VK_ENTER:  choice = YES; setVisible(false); break;
       		 case java.awt.event.KeyEvent.VK_N:
                 case java.awt.event.KeyEvent.VK_ESCAPE: choice = NO; setVisible(false); break;
       		 default: break;
       		}
   		}

	}



	public void actionPerformed(java.awt.event.ActionEvent event)
	{
	   Object object = event.getSource();
	   if (object == buttonYes)
	     {
          choice = YES;
              setVisible(false);
	     }
	   else if (object == buttonNo)
         {
          choice = NO;
          setVisible(false);
		 }
	}


}
