/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;


/**
   DoPanel
   est un panel d'alignement sans fond
*/

public class DoPanel extends Container
{
    /**
     * Creates a new DoPanel 
     */
    public DoPanel() { }


    public void update(Graphics g)
    {
     paint(g);
    }

    public void paint(Graphics g)
    {
     super.paint(g);
    } // paint

	private Component userPanel = null;   
   
    public void setLayout(LayoutManager l) {}
   
	public void doLayout()
	{
		Rectangle r = getBounds();

		int width = r.width - TF_LEFT + TF_RIGHT;
		if (width < 0) return;

		int height = r.height - TF_TOP + TF_BOTTOM;
		if (height < 0)	return;

		int col = TF_LEFT;
		int row = TF_TOP;

		if (userPanel != null)
		{
			userPanel.setBounds(col + 3, row + 3, width-6, height-5);
			userPanel.invalidate();
			userPanel.validate();
            if (userPanel instanceof Canvas || userPanel instanceof Panel)
            {
			    userPanel.repaint();
		    }
		    else
		    {
		        repaint();
        	}

		}
	}


    public Component add(Component p)
    {
     super.add(p);
     userPanel = p;
     return p;
    }    
    
	private int TF_LEFT = 0;
	private int TF_RIGHT = 0;//-1;
	private int TF_TOP = 24;//30;
	private int TF_BOTTOM = -2;
	private int TF_BTN_HEIGHT = 20;     // sera surcharg

   
}
