/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import common.*;

/**
   Zone d'change de donnes
*/

public class FindReplace
{
    String m_findme;
    String m_replace;
    boolean m_matchCase;
    boolean m_selectedArea;
    boolean m_replaceAll;
    boolean m_cancel;
    boolean m_foundIt;
    boolean m_replaceIt;
    boolean confirm;
    boolean edited;
    int m_numoccur = 0;
    int m_current_index = 0;
    java.awt.TextComponent m_body;
    TextModel tm;

    /** Constructeur recherche/remplacement */
    public FindReplace(String findthis, String replacethis, TextComponent thebody)
    {
     setFind(findthis);
     setReplace(replacethis);
     setBody(thebody);
     setCase(false);
     setConfirm(true);
     setEdited(false);
 		//{{INIT_CONTROLS
		//}}
}

    /** Constructeur pour recherche seule */
    public FindReplace(String findthis, TextComponent tc)
    {
       this(findthis, null,tc);
    }

    /** Constructeur gnral */
    public FindReplace(TextComponent tc, TextModel t)
    {
       this(null, null,tc);
       tm = t;
    }

    // mthodes
    public void setReplaceIt(boolean replace) { m_replaceIt = replace; }
    public boolean isReplaceIt() { return m_replaceIt; }

    public void setBody(TextComponent body) { m_body = body; }
    public TextComponent getBody() { return m_body; }

    public void setFind(String findthis) { m_findme = findthis;}
    public String getFind() { return m_findme; }

    public void setReplace(String replacethis) { m_replace = replacethis; }
    public String getReplace() { return m_replace; }

    public void setIndex(int index) { m_current_index = index;
      //System.out.println("FR set index=" + index);
      //System.out.println("find " + m_findme);
    }
    public int getIndex() {
      //Disp.it("FR get index=" + m_current_index);
    return m_current_index; }

    public void setFoundIt(boolean foundit) { m_foundIt = foundit; }
    public boolean isFoundIt() { return m_foundIt; }

    public void setOccur(int numtimes) { m_numoccur = numtimes; }
    public int getOccur() { return m_numoccur; }
    public void incOccur() { m_numoccur++; }

    public void setCase(boolean matchcase) { m_matchCase = matchcase; }
    public boolean isCase() { return m_matchCase; }

    public void setConfirm(boolean c) { confirm = c; }
    public boolean isConfirm() { return confirm; }

    public void setSelectArea(boolean select) { m_selectedArea = select; }
    public boolean isSelectArea() { return m_selectedArea; }

    public void setReplaceAll(boolean replaceall) { m_replaceAll = replaceall; }
    public boolean isReplaceAll() { return m_replaceAll; }

    public void setCancel(boolean cancel) { m_cancel = cancel; }
    public boolean isCancel() { return m_cancel; }

    public void setEdited(boolean e) { edited = e; }
    public boolean isEdited() { return edited; }

    /** Place l'index au dbut de la chane slectionne */
    public void setIndexAtSelection() { setIndex(m_body.getSelectionStart());  }

    /** Place l'index au curseur*/
    public void setIndexAtCaret()
     {
       int index = tm.getCaretPosition();
       if(index < 0 ) index = 0;
       setIndex(index);
     }

    /** Place l'index pour une seconde recherche */
    public void setIndexToFind()
    {
     if(tm.isSelected()) setIndex(tm.getSelectionEnd());
     else                setIndexAtCaret();
    }

   /** Place l'index pour un remplacement */
    public void setIndexToReplace()
    {
     if(tm.isSelected()) setIndex(tm.getSelectionStart());
     else                setIndexAtCaret();
    }


     /**
        Prend la slection comme chaine  chercher
        dans text model, et la met
        dans m_findMe
     */

     public boolean setSelection(TextModel tm)
     {
	    //automatically put in selection in FindDialog field
	    int select_start = tm.getSelectionStart();
	    int select_end   = tm.getSelectionEnd();
	    int select_diff  = select_end - select_start;

	    //set find field if selected text not too big
        boolean ret = false;
	    if(select_diff > 0 && select_diff <= 32)
        {
         setFind(tm.getSelectedText().trim());
         ret = true;
        }

        setIndex(select_end);
        setOccur(0);
        return ret;
     }

	//{{DECLARE_CONTROLS
	//}}
}
