/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.lang.*;
import java.awt.*;
import common.*;

public class FindReplaceEngine
{
    private FindReplace FR;
    public boolean cancelled;

    /** Constructor  */
    public FindReplaceEngine(FindReplace fr)
    {
      FR = fr;
    }


  /** Recherche  */
  boolean FindIt()
   {
	int searchLen;
    int startindex;
    int nextindex;
	int foundit_index;
	String found_string;
	String string_to_find;
	String body;

    boolean foundit = false;        // Assume we won't find it
    boolean eofReached = false;

    if(FR.isCase())
    {
     body = FR.getBody().getText();
     string_to_find = FR.getFind();
    }
    else
    {
     body = FR.getBody().getText().toUpperCase();
     string_to_find = FR.getFind().toUpperCase();
    }

    searchLen = string_to_find.length();

    while(!foundit && !eofReached)
     {
      //Disp.it("search " + string_to_find);
      startindex = FR.getIndex();
      //Disp.it("FRE startindex " + startindex);
      foundit_index = body.indexOf(string_to_find, startindex);
      //Disp.it("FRE index trouv " + foundit_index);
      if(foundit_index == -1) eofReached = true;
      else
       {
        foundit = true;
        nextindex = foundit_index + searchLen;
        if(FR.isCase())  // On prend la chaine originale
        {
         found_string = FR.getBody().getText().substring(foundit_index, nextindex);
         //Disp.it("found " + found_string);
        }
        // HILIGHT et dcompte
        FR.setIndex(nextindex);
        FR.getBody().select(foundit_index, nextindex);
        FR.incOccur();
      }
    }

     //Disp.it("this index=" + FR.getIndex());
	 FR.setFoundIt(foundit);
     return foundit;
   }

    /** Remplace et retourne l'index suivant dans TextArea */
    public int ReplaceIt()
    {
      TextArea ta = (TextArea) FR.getBody();
      TextModel tm = new TextModel(ta);
      int sindex = FR.getIndex();
      tm.replace(FR.getReplace());
      //Disp.it("next index=" + (sindex + FR.getReplace().length()));
      FR.setEdited(true);
      return sindex + FR.getReplace().length();
    }

    public void ReplaceAll()
    {
	   FindIt();
       cancelled = false;
	   while(FR.isFoundIt() && !cancelled)
	    {
	      FR.setIndex(ReplaceIt());
	      FindIt();
	    }
	}

	/*
	    The '/n' is counted as a character so we must find out
	    how many lines down the word found is and subtract that
	    many chars from the count.
	*/
 /*
	public int LinesDown(int ending)
	{
	    String working_body;
	    int whichchar = 0;
	    int line = 0;

	    working_body = FR.getBody().getText();

	    while(whichchar <= ending)
	    {
	        if(working_body.charAt(whichchar) == '\n') line++;
	        whichchar++;
	    }

	    return line;
    }
*/
}
