/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;
import common.*;

/*
   Last messages
*/

public class History extends Frame implements ActionListener, WindowListener
{
    static final int rows = 24;
    static final int cols = 60;
    int counter;
    int MAXITEMS = 100;

    TextArea info;
    Button buttonClose;

    /** constructeur */
    public History(int maxitems)
    {
	 super(" Last 100 messages ");

	 setFont(new Font("Dialog", Font.PLAIN, 14));

	 add(info = new TextArea(rows, cols), BorderLayout.CENTER);
	 info.setEditable(false);
	 info.setBackground(java.awt.SystemColor.window);

	 Panel panelButtons = new Panel();
     panelButtons.setBackground(java.awt.SystemColor.control);
	 add(panelButtons, BorderLayout.SOUTH);

	 panelButtons.add(buttonClose = new Button("  Close  "));
	 buttonClose.addActionListener(this);

     addWindowListener(this);

     pack();

     MAXITEMS = maxitems;
     counter = 0;
		//{{INIT_CONTROLS
		setLayout(null);
		setSize(430,270);
		setTitle("Untitled");
		//}}
		//{{INIT_MENUS
		//}}
}

    public History() { this(100); }


    /** Affiche le tableau */
    public void setVisible(boolean b)
    {
	 super.setVisible(b);
    }

    /** Ajoute un message */
    public void tell(String s)
    {
      if(counter >= MAXITEMS)
      {
       //info.setText("");
       String text = info.getText();
       int i = text.indexOf("\n");
       info.setText(text.substring(i + 1));
       counter = MAXITEMS - 1;   // One line suppressed
       System.gc();
     }


     s = s + "\n";
     //System.out.println("append " + s);
	 info.append(s);
    }

    public void actionPerformed(ActionEvent e)
    {
	 setVisible(false);
    }

    public void setStyle(Style s)
    {
     info.setFont(s.font);
     info.setBackground(s.background);
     info.setForeground(s.foreground);
    }

    public void windowOpened(WindowEvent e) {}
    public void windowClosed(WindowEvent e) {}
    public void windowIconified(WindowEvent e) {}
    public void windowDeiconified(WindowEvent e) {}
    public void windowActivated(WindowEvent e) {}
    public void windowDeactivated(WindowEvent e) {}
    public void windowClosing(java.awt.event.WindowEvent event)
    {
        if (event.getSource() == History.this) setVisible(false);
    }
}
