/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;

public class KeyDialog extends DDialog
{
  public static final int NO = 0;
  public static final int YES = 1;
  public static final int CANCEL = 2;
  public int answer = CANCEL;

  public KeyDialog(Frame parent, boolean modal)
   {
      super(parent, modal); // ajoute keyListener
      keyEnabled = true;
   }

  public KeyDialog(Frame parent)
  {
	  this(parent, true);
  }


  public KeyDialog(Frame parent, String title)
   {
      this(parent, true);
      setTitle(title);
   }


  public void keyPressed(java.awt.event.KeyEvent event)
   {
     if(event.isControlDown() || event.isAltDown()) return;
     if(!keyEnabled) return;

     switch(event.getKeyCode())
      {
                 case java.awt.event.KeyEvent.VK_ENTER:  answer = YES; setVisible(false); break;
                 case java.awt.event.KeyEvent.VK_ESCAPE: answer = CANCEL; setVisible(false); break;
                 case java.awt.event.KeyEvent.VK_Y: answer = YES; setVisible(false); break;
                 case java.awt.event.KeyEvent.VK_N: answer = NO; setVisible(false); break;
   		 default: break;
  	  }
   }

  public int getAnswer() { return answer; }

}
