/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.Image;
import java.awt.Color;
import java.awt.FontMetrics;
import java.net.URL;
import common.*;

/**
 * This class is not public and therefore cannot be used outside this package.
 */


public class ListItem implements java.io.Serializable
{
	URL                 url = null;
	transient Image     image;
	String              sText;
	boolean             bEnabled;
	boolean             bSelected;
	transient boolean   bDirty;          // Vrai si on repeint le fond de l'lment
	Color               color;
	int                 lineWidth;
	boolean             bCellBorder;
	Color               cellBorderColor;
	boolean             bEdited = false;
	
	// Rajout
	boolean             deleted = false;  // Fichier marqu pour effacement
    boolean             tagged = false;   // Fichier marqu pour copie, etc... 


	public ListItem(Image image, String sText, boolean bEnabled, FontMetrics fm, boolean bCellBorder)
	{
		this.image = image;
		this.sText = sText;
		this.bEnabled = bEnabled;
		this.bSelected = false;
		this.bDirty = true;
		this.color = null;
		this.bCellBorder = bCellBorder;
		this.cellBorderColor = Color.black;
		updateWidth(fm);
			//{{INIT_CONTROLS
		//}}
}

	public ListItem(Image image, URL url, String sText, boolean bEnabled, FontMetrics fm, boolean bCellBorder)
	{
	    this(image, sText, bEnabled, fm, bCellBorder);
	    this.url = url;
	}

	public void updateWidth(FontMetrics fm)
	{
		if (fm != null)	this.lineWidth = fm.stringWidth(sText);
		else			this.lineWidth = 0;
	}

	public String toString()
	{
	  	String s = "ListItem " + sText;
	  	
 	 	if (image != null) 			s += " [Image]";
 	 	if (color != Color.black)   s += " [Colored]";
	  	if (bEnabled)   	 		s += " [Enabled]";
  		else            	  		s += " [Disabled]";
 	 	if (bSelected)  			s += " [Selected]";
  		else            			s += " [Not Selected]";
	  	if (bDirty)     	 		s += " [Dirty]";
		return s;
	}
	//{{DECLARE_CONTROLS
	//}}
}

