/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.lang.*;
import java.awt.*;
import java.io.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import common.*;

public class LocateEngine extends java.lang.Object
{
    List listbox;
    boolean sortie;
    boolean selectFlag = false;
    String file_to_locate;  // name to search
    String[] files;
    String foundpath;       // path with found file
    String found;           // read name
    String basepath;
    int m_numoccur = 0;
    public boolean MultipleSearch = true;
    boolean diralso = false;
    boolean dispcurrent = false;
    Label labelDir;    // imported from LocateDialog



    public LocateEngine(String bp, String tofind, List dlb, boolean diralso)
     {
        this.basepath = bp;
        this.diralso = diralso;
        this.listbox = dlb;
        sortie = false;

        files = new String[1];
        if(OS.isWindows())
          files[0] = tofind.toUpperCase();
        else
          files[0] = tofind;
     }


    public LocateEngine(String bp, String[] tofind, List dlb, boolean diralso)
     {
         this.basepath = bp;
         this.diralso = diralso;
         this.listbox = dlb;
         sortie = false;

         int l = tofind.length;
         files = new String[l];
         if(OS.isWindows())
         {
           for (int i = 0; i < l; i++)
           {
             files[i] = tofind[i].toUpperCase();
           }
         }
     }

   public void setLabel(Label l)
   {
      labelDir = l;
   }


   public boolean searchdir(String treepath)
     {

        if(sortie) return true;

        if(dispcurrent)
        {
         listbox.remove(0);
         listbox.add(treepath, 0);
        }

        labelDir.setText(treepath);

        // file inside directory
        boolean bfound = false;
        File fic = null;
        int i;

        for (i = 0; i < files.length; i++)
        {
         fic = new File(treepath, files[i]);
         if (fic.exists())
         {
           if(!diralso) { if (fic.isDirectory()) continue; }
           bfound = true;
           break;
         }
        }

        // found
        if(bfound)
         {
          found     = fic.getName();
          foundpath = fic.getPath();
          incOccur();
          AddIt();

          if(MultipleSearch == false)
          {
            sortie = true;
            return true;
          }

         }

        File dir = new File(treepath, File.separator);
        String dlist[] = null;
        try { dlist = dir.list(); }
        catch (NullPointerException e) { Disp.it("Array not filled"); }

        // On envisage la recherche de rpertoire

        int l = dlist.length;
        int index = 0;
        while((index < l) && !sortie)
         {
           File test = new File(treepath, dlist[index]);
           if(test.isDirectory())
           {
             if(test.canRead())
              searchdir(treepath + File.separator + dlist[index]);
           }
           index++;
         }

       return sortie;
     }


    public void FindIt()
    {
	  searchdir(basepath);
    }

    public int AddIt()
    {
        listbox.add(foundpath);
        if(selectFlag)
        {
           listbox.select(listbox.getItemCount() - 1);
        }

        // first occurence only
        if(m_numoccur == 1) sourceActionEvent();
        return 1;
    }



    public void setOccur(int n) { m_numoccur = n; }
    public int getOccur()       { return m_numoccur; }
    public void incOccur()      { m_numoccur++; }


    // GESTION EVENEMENTS

	ActionListener actionListener = null;

    /** Fire an action event to the listeners */
	protected void sourceActionEvent()
	{
	  if (actionListener != null)
		actionListener.actionPerformed(new ActionEvent(this, ActionEvent.ACTION_PERFORMED, "found"));
	}

    /** Adds the specified action listener */
	public void addActionListener(ActionListener l)
	{
	  actionListener = AWTEventMulticaster.add(actionListener, l);
	}

    /** Removes the specified action listener */
	public void removeActionListener(ActionListener l)
	{
	  actionListener = AWTEventMulticaster.remove(actionListener, l);
	}

}
