/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.io.*;
import java.util.*;
import java.awt.*;
import common.*;

public class Preferences
{

  static DProperties p = null;
  static DProperties config = null;
  static public String Dir = System.getProperty("user.dir");
  static public String Filename = "AE.Init";
  /*
  static {
    String EOF;
    if (OS.isWindows())      EOF = "\r\n";
    else if(OS.isMacintosh()) EOF = "\r";
    else EOF = "\n";
  }
  */
  static public boolean WINDOWS = OS.isWindows();

  // General
  static public int MemorySize = 16;
  static public int MemBaseSize = 3;
  static public boolean SaveMemory = false;
  static public boolean AutoSave = false;
  static public Color UserColor;
  static public int CurrentStyle;
  static public boolean Sound;
  static public Color PrgBg;
  static public Color PrgFg;
  static public String sPrgBg;
  static public String sPrgFg;
  static public Style MessageStyle = new Style();
  static public int Language;
  static public int tabStyle = 1;
  static public int menuSize = 16;
  static public int panelTarget = 0;

  // Dir
  static public boolean ArcSort = true;
  static public boolean AskDeleteDir = true;
  static public boolean AskDeleteFile = false;
  static public boolean AskReplace = false;
  static public boolean AskHtml = false;
  static public boolean MakeBak = true;
  static public boolean ArcRestore = true;
  static public boolean ArcReplace = true;
  static public boolean OpenDir = true;
  static public Style DirStyle = new Style();
  static public String shortcut[]= { "","","","","","","",""};
  static public String longpath[]= { "","","","","","","",""};

  // Arc
  static public boolean ArcRecurse = true;
  static public boolean ArcInclude = true;
  static public boolean StoreOnly = false;

  // Image
  static public boolean Scale;
  static public boolean Direct;
  static public boolean FScale;

  // Tree
  static public Style TreeStyle = new Style();
  static public boolean FLOPPIES = false;

  // Style
  static public Style TextStyle = new Style();

  // Texte
  static public boolean EditorAss = false;
  static public boolean wordWrap = true;
//  static public boolean disableAss;

  // Ass
  static public int AssNumber = 0;
  static public boolean AssFirst = false;
  static public String edName = "wordpad.exe";
  static public String htmName = "iexplore.exe";
  static public String playPath = ""; // pas sauv
  static public String paintPath = "";
  static public String helpPath = "";
  static public String pdfPath = "";


  // Web page
  static String pageColor = "None";

  // Thumbnail
  static int ThumbWidth = 64;
  static int ThumbCell = 68;
  static boolean ThumbBorder = true;
  static boolean ThumbName = true;
  static boolean ThumbSize = true;
  static boolean ThumbType = true;


  // Langage
  static final int ENGLISH = 0;
  static final int FRANCAIS = 1;
  static final int ESP = 2;
  static final int DEU = 3;
  static final int RUS = 4;
  static final int ITA = 5;
  static final int POR = 6;
  static final int DAN = 7;
  static final int NOR = 8;
  static final int SWE = 9;
  static final int FIN = 10;
  static final int ROM = 11;
  static final int POL = 12;
  static final int HUN = 13;
  static final int TCH = 14;
  static final int SLO = 15;
  static final int OTHER = 15;

  static public String[] LangFile = {
   "AEEng",
   "AEFra",
   "AEEsp",
   "AEDeu",
   "AERus",
   "AEIta",
   "AEPor",
   "AEDan",
   "AENor",
   "AESve",
   "AESuo",
   "AERom",
   "AEPol",
   "AEHun",
   "AECes",
   "AESlo",
   "AEOth",
  };


 static VectorString navigator = new VectorString(3);
 static VectorString editor = new VectorString(3);
 static VectorString painter = new VectorString(3);
 static VectorString viewer = new VectorString(3);
 static VectorString helper = new VectorString(3);
 static VectorString player = new VectorString(3);

 /** Chargement */

 static public boolean configLoad()
 {
   boolean ok = false;

   config = new DProperties();
   try { ok = (config.load(Dir, "AE.config") > 0);  }
   catch (Exception e) { e.printStackTrace(); }

   if(WINDOWS)
   {
     navigator = config.get("Navigator", "iexplore.exe", "netscape.exe");
     editor = config.get("Editor", "wordpad.exe", null);
     painter = config.get("Painter", "mspaint.exe", null);
     viewer = config.get("DocViewer", "acrord32.exe", "gsview.exe");
     helper = config.get("Helper", "winhelp.exe", null);
     player = config.get("Player", "mplayer.exe", "mplayer2.exe");
   }
   else
   {
     navigator = config.get("Navigator", "mozilla", "konqueror");
     editor = config.get("Editor", "kedit", "gedit");
     painter = config.get("Painter", "kpaint", "gimp");
     viewer = config.get("DocViewer", "gsview", null);
     helper = config.get("Helper", "gsview", null);
     player = config.get("Player", "kview", "xine");
   }

   return ok;
 }

 static public boolean Load()
 {
   boolean ok = false;


   p = new DProperties();   // Efface le tableau
   try { ok = (p.load(Dir, Filename) > 0);  }
   catch (Exception e) { e.printStackTrace(); }

   //Disp.it("load=" + ok);
   DirStyle.set("window", "windowText", "Dialog", Font.PLAIN, 16);
   TextStyle.set("slate", "black", "SansSerif", Font.PLAIN, 16);
   TreeStyle.set("window", "windowText", "Dialog", Font.PLAIN, 12);
   MessageStyle.set("control", "controlText", "Helvetica", Font.BOLD, 14);

   // General
   MemorySize  = p.get("DirListSize", 16);
   MemBaseSize = p.get("DirListBase", 3);
   menuSize = p.get("MenuSize", 8);
   SaveMemory  = p.get("SaveDirList", true);
   AutoSave    = p.get("AutoSaveSetup", true);
   UserColor    = p.stringToColor(p.get("UserColor", Color.lightGray));
   CurrentStyle = p.get("CurrentStyle", 0);
   Sound = p.get("Sound", true);
   sPrgBg = p.get("PrgBackground", "control");
   sPrgFg = p.get("PrgForeground", "controlText");
   PrgBg = ColorList.getColor(sPrgBg);
   PrgFg = ColorList.getColor(sPrgFg);
   MessageStyle.tokenize( p.get("MessageStyle", MessageStyle));
   Language    = p.get("Language", 0);
   tabStyle = p.get("TabStyle", 2);
   panelTarget = p.get("PanelTarget", 0); // lequel affich?


   Scale = p.get("PanelScaled", false);
   Direct = p.get("ImageDirect", false);
   FScale = p.get("ScreenScaled", true);

   // Dir
   AskDeleteDir   = p.get("AskToDeleteDir", true);
   AskDeleteFile  = p.get("AskToDeleteFile", false);
   AskReplace  = p.get("AskReplace", true);
   AskHtml  = p.get("AskHtml", false);
   DirStyle.tokenize( p.get("DirStyle", DirStyle));

   // Archive
   ArcSort = p.get("ArcSorting", false);
   ArcRecurse  = p.get("ArcRecurse", true);
   ArcInclude  = p.get("ArcInclude", true);
   StoreOnly   = p.get("StoreOnly", false);
   ArcRestore  = p.get("ArcRestore", true);
   ArcReplace  = p.get("ArcReplace", true);
   OpenDir     = p.get("OpenDir", true);

   // Tree
   TreeStyle.tokenize( p.get("TreeStyle", TreeStyle));
   FLOPPIES   = p.get("Floppies", false);

   // Text
   MakeBak     = p.get("MakeBak", true);
   TextStyle.tokenize( p.get("TextStyle", TextStyle));
   EditorAss = p.get("EditorAssoc", false);
   edName = p.get("Editor", "wordpad.exe");
   wordWrap = p.get("WrapAround", true);
//   disableAss = p.get("DisableAssoc", false);

   // Assoc
   AssNumber = p.get("AssocNumber", 0);
   AssFirst  = p.get("AssocPriority", false);

   if(OS.isWindows())
   {
     edName = p.get("EditorPath", "wordpad.exe");
     htmName = p.get("NavigatorPath", "iexplore.exe");
   }
   else
   {
     edName = p.get("EditorPath", "kedit");
     htmName = p.get("NavigatorPath", "mozilla");
   }
   playPath = p.get("PlayerPath", "");
   paintPath = p.get("PainterPath", "");
   helpPath = p.get("HelperPath", "");
   pdfPath = p.get("PdfPath", "");

   // Web page
   pageColor = p.get("PageColor", "None");

   // Thumbnail
   ThumbWidth  = p.get("ThumbWidth", 80);
   ThumbCell = p.get("ThumbCell", 84);
   ThumbBorder = p.get("ThumbBorder", false);
   ThumbName   = p.get("ThumbName", true);
   ThumbSize   = p.get("ThumbSize", true);
   ThumbType   = p.get("ThumbType", true);

   // shortcut
   if(WINDOWS)
   {
     shortcut[0] = p.get("button0", "a:");
     shortcut[1] = p.get("button1", "c:");
     shortcut[2] = p.get("button2", "d:");
     shortcut[3] = p.get("button3", "e:");
     shortcut[4] = p.get("button4", "f:");
     shortcut[5] = p.get("button5", "g:");
     shortcut[6] = p.get("button6", "h:");
     shortcut[7] = p.get("button7", "i:");

     longpath[0] = p.get("path0", "a:");
     longpath[1] = p.get("path1", "c:");
     longpath[2] = p.get("path2", "d:");
     longpath[3] = p.get("path3", "e:");
     longpath[4] = p.get("path4", "f:");
     longpath[5] = p.get("path5", "g:");
     longpath[6] = p.get("path6", "h:");
     longpath[7] = p.get("path7", "i:");
   }
   else
   {
     shortcut[0] = p.get("button0", "/");
     shortcut[1] = p.get("button1", "root");
     shortcut[2] = p.get("button2", "usr");
     shortcut[3] = p.get("button3", "home");
     shortcut[4] = p.get("button4", "windows");
     shortcut[5] = p.get("button5", "floppy");
     shortcut[6] = p.get("button6", "cdrom");
     shortcut[7] = p.get("button7", "zip");

     longpath[0] = p.get("path0", "/");
     longpath[1] = p.get("path1", "/root");
     longpath[2] = p.get("path2", "/usr");
     longpath[3] = p.get("path3", "/home");
     longpath[4] = p.get("path4", "/windows");
     longpath[5] = p.get("path5", "/floppy");
     longpath[6] = p.get("path6", "/cdrom");
     longpath[7] = p.get("path7", "/zip");
   }

   return ok;
 } // Load


  // Afficher sur console
  static public void Disp()
  {
     p.list(System.out);
  }

 /** Reconstruction et sauvegarde */
 public static boolean Save()
 {
     p = new DProperties(64);

     p.put("#General");
     p.put("DirListSize",  MemorySize);
     p.put("DirListBase",  MemBaseSize);
     p.put("MenuSize",     menuSize);
     p.put("SaveDirList",  SaveMemory);
     p.put("AutoSaveSetup",AutoSave);
     p.put("UserColor",    UserColor);
     p.put("CurrentStyle", CurrentStyle);
     p.put("Sound",        Sound);
     p.put("PrgBackground", sPrgBg);
     p.put("PrgForeground", sPrgFg);
     p.put("MessageStyle",  MessageStyle);
     p.put("Language",      Language);
     p.put("TabStyle",      tabStyle);
     p.put("PanelTarget",   panelTarget);

     p.put("#Images");
     p.put("PanelScaled",  Scale);
     p.put("ImageDirect",  Direct);
     p.put("ScreenScaled",  FScale);

     p.put("#Directories");
     p.put("AskToDeleteDir",  AskDeleteDir);
     p.put("AskToDeleteFile", AskDeleteFile);
     p.put("AskReplace",      AskReplace);
     p.put("AskHtml",         AskHtml);
     p.put("DirStyle",        DirStyle);

     p.put("#Archives");
     p.put("ArcSorting", ArcSort);
     p.put("ArcRecurse",     ArcRecurse);
     p.put("ArcInclude",     ArcInclude);
     p.put("StoreOnly",      StoreOnly);
     p.put("ArcRestore",      ArcRestore);
     p.put("ArcReplace",      ArcReplace);
     p.put("OpenDir",      OpenDir);

     p.put("#Tree");
     p.put("TreeStyle", TreeStyle);
     p.put("Floppies", FLOPPIES);

     p.put("#Text");
     p.put("MakeBak",    MakeBak);
     p.put("TextStyle",  TextStyle);
     p.put("EditorAssoc",     EditorAss);
     p.put("Editor", edName);
     p.put("WrapAround", wordWrap);
  //   p.put("DisableAssoc", disableAss);

     p.put("#Associations");
     p.put("AssocNumber", AssNumber);
     p.put("AssocPriority", AssFirst);
     /*
     p.put("DefaultEditor", edDefault);
     p.put("DefaultNavigator",  htmDefault);
     p.put("DefaultPlayer",  playDefault);
     p.put("DefaultPainter",  paintDefault);
     p.put("DefaultHelper",  helpDefault);
     p.put("DefaultPdf",  pdfDefault);
     */

     p.put("EditorPath", edName);
     p.put("NavigatorPath", htmName);
     p.put("PlayerPath", playPath);
     p.put("PainterPath", paintPath);
     p.put("HelperPath", helpPath);
     p.put("PdfPath", pdfPath);

     // Page
     p.put("#Web page");
     p.put("PageColor", pageColor);


     // Thumbnail
     p.put("#ThumbNail");
     p.put("ThumbWidth", ThumbWidth);
     p.put("ThumbCell", ThumbCell);
     p.put("ThumbBorder", ThumbBorder);
     p.put("ThumbName", ThumbName);
     p.put("ThumbSize", ThumbSize);
     p.put("ThumbType", ThumbType);

     // shortcut
    p.put("button0", shortcut[0]);
    p.put("button1", shortcut[1]);
    p.put("button2", shortcut[2]);
    p.put("button3", shortcut[3]);
    p.put("button4", shortcut[4]);
    p.put("button5", shortcut[5]);
    p.put("button6", shortcut[6]);
    p.put("button7", shortcut[7]);

    p.put("path0", longpath[0]);
    p.put("path1", longpath[1]);
    p.put("path2", longpath[2]);
    p.put("path3", longpath[3]);
    p.put("path4", longpath[4]);
    p.put("path5", longpath[5]);
    p.put("path6", longpath[6]);
    p.put("path7", longpath[7]);

     int r = p.save(Dir, Filename);

     return r > 0;
}


 public static boolean delete()
 {
    return DProperties.delete(Dir, Filename);
 }
} // Preferences


