/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;
import common.*;

public class ReplaceConfirmDialog extends DDialog implements ActionListener
{
    FindReplaceEngine FRE;
    FindReplace FR;

	java.awt.Label labelConfirm;
	java.awt.Button btn_yes;
	java.awt.Button btn_no;
    java.awt.Button btn_all;
	java.awt.Button btn_cancel;

    //public ReplaceConfirmDialog() {;}

	public ReplaceConfirmDialog(Frame parent, boolean modal)
	{
		super(parent, modal);
		setSize(getInsets().left + getInsets().right + 352,getInsets().top + getInsets().bottom + 88);

		labelConfirm = new java.awt.Label("Replace this occurrence?");
		labelConfirm.setFont(new Font("Courrier", Font.PLAIN, 15));
		labelConfirm.setBounds(getInsets().left + 16,getInsets().top + 12,188, 20);
		panel.add(labelConfirm);

		btn_yes = new java.awt.Button("Yes");
		btn_yes.setBounds(getInsets().left + 254,getInsets().top + 12, 72,24);
        btn_yes.setBackground(getBackground());
		btn_yes.addActionListener(this);
		panel.add(btn_yes);

		btn_no = new java.awt.Button("No");
		btn_no.setBounds(getInsets().left + 254,getInsets().top + 48, 72, 24);
		btn_no.setBackground(getBackground());
		btn_no.addActionListener(this);
		panel.add(btn_no);

		btn_cancel = new java.awt.Button("Cancel");
		btn_cancel.setBounds(getInsets().left + 16,getInsets().top + 48, 72, 24);
		btn_cancel.setBackground(getBackground());
		btn_cancel.addActionListener(this);
		panel.add(btn_cancel);

		btn_all = new java.awt.Button("All");
		btn_all.setBounds(getInsets().left + 116,getInsets().top + 48, 72, 24);
		btn_all.setBackground(getBackground());
		btn_all.addActionListener(this);
		panel.add(btn_all);

		setTitle("Confirm");

        btn_yes.requestFocus();
        btn_yes.addKeyListener(new DialogKey());
			//{{INIT_CONTROLS
		//}}
}


	public ReplaceConfirmDialog(Frame parent, String title, boolean modal, FindReplace replace)
	{
		this(parent, modal);
		setTitle(title);
		FR = replace;
        FRE = new FindReplaceEngine(FR);

        // Initialisation
          //Disp.it("repl conf dlg, foundit false, caret=" + FR.getIndex());
        if(!FRE.FindIt())
         {
          labelConfirm.setText("No found - Click on Cancel");
          Tool.beep();
          return;
         }

        FR.setIndexToReplace();
          //Disp.it("trouve " + FR.getFind() + " en " + FR.getIndex());

	}



	public void actionPerformed(java.awt.event.ActionEvent event)
	{
		Object object = event.getSource();

        if(!FR.isFoundIt()) { setVisible(false); return; }
 	    if (object == btn_yes)
         {
          FR.setIndex(FRE.ReplaceIt());
          if(!FRE.FindIt()) labelConfirm.setText("No more occurence");
         }
                else if (object == btn_all)             { FRE.ReplaceAll(); setVisible(false); }
		else if (object == btn_no)
       	{
          FR.setIndexToFind();
          if(!FRE.FindIt()) setVisible(false);
        }
                else if (object == btn_cancel)  { FRE.cancelled = true; setVisible(false); }
	}

    class DialogKey extends java.awt.event.KeyAdapter
	{
	  public void keyPressed(java.awt.event.KeyEvent event)
	   {
        if(event.isControlDown() || event.isAltDown()) return;

        switch(event.getKeyCode())
         {
       	   case java.awt.event.KeyEvent.VK_ENTER:
              FR.setIndex(FRE.ReplaceIt());
              if(!FRE.FindIt()) labelConfirm.setText("No more occurence");
       	     break;
       	   case java.awt.event.KeyEvent.VK_ESCAPE:
                { FRE.cancelled = true; setVisible(false); }
       	     break;
       	   default: break;
       	 }
        }

	}

	//{{DECLARE_CONTROLS
	//}}
}
