/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;
import common.*;

public class ReplaceDialog extends DDialog implements ActionListener, KeyListener
{
    Frame parentFrame;
	DCheckbox checkCase;
	DCheckbox checkConfirm;

	TextField fieldFind;
	TextField fieldReplace;

	Button buttonReplace;
	Button buttonReplaceAll;
	Button buttonCancel;

	FindReplace FR;


	public ReplaceDialog(Frame parent, boolean modal)
	{
		super(parent, modal);
		//setSize(insets().left + insets().right + 452,insets().top + insets().bottom + 144);
        setSize(452, 144);
        parentFrame = parent;


		Label labelReplace = new java.awt.Label("Replace",Label.RIGHT);
		labelReplace.setBounds(10, 16, 60, 22);
		panel.add(labelReplace);

		fieldFind = new java.awt.TextField();
		fieldFind.setBounds(76, 16,274,24);
		fieldFind.addKeyListener(this);
		panel.add(fieldFind);

		Label labelBy = new java.awt.Label("by",Label.RIGHT);
		labelBy.setBounds(10, 48, 60, 22);
		panel.add(labelBy);

		fieldReplace = new java.awt.TextField();
		fieldReplace.setBounds(76,48,275,25);
		fieldReplace.addKeyListener(this);
		panel.add(fieldReplace);

		checkCase = new DCheckbox("Case Sensitive");
		checkCase.setBounds(76, 88, 132, 24);
		panel.add(checkCase);

		checkConfirm = new DCheckbox("Confirm");
		checkConfirm.setBounds(76, 112, 100, 24);
		panel.add(checkConfirm);

		buttonReplace = new java.awt.Button("Replace");
		buttonReplace.setBounds(354, 16, 88, 25);
		buttonReplace.setBackground(getBackground());
		buttonReplace.addActionListener(this);
		panel.add(buttonReplace);

		buttonReplaceAll = new java.awt.Button("Replace All");
		buttonReplaceAll.setBounds(354, 48, 88, 25);
		buttonReplaceAll.setBackground(getBackground());
		buttonReplaceAll.addActionListener(this);
		panel.add(buttonReplaceAll);

		buttonCancel = new java.awt.Button("Cancel");
		buttonCancel.setBounds(354, 104, 88, 26);
		buttonCancel.setBackground(getBackground());
		buttonCancel.addActionListener(this);
		panel.add(buttonCancel);

		//setTitle(" Replace");

	}


	public ReplaceDialog(Frame parent, String title, boolean modal, FindReplace fr)
	{
		this(parent, modal);  // appelle l'autre constructeur
		setTitle(title);

		FR = fr;
		fieldFind.setText(FR.getFind());
		fieldReplace.setText(FR.getReplace());

		checkCase.setState(FR.isCase());
       	checkConfirm.setState(FR.isConfirm());
	}




   public void actionPerformed(java.awt.event.ActionEvent event)
	{
		 Object object = event.getSource();
		 if (object == buttonReplace)
          {
	       if(checkConfirm.getState() == false) replaceAll();
           else  replaceOne();
           return;
          }
		 else if (object == buttonReplaceAll)	replaceAll();
                 else if (object == buttonCancel)       setVisible(false);
         else if (object == checkConfirm)
          {
            boolean i = !checkConfirm.getState(); // inversion
            checkConfirm.setState(i);
  	        FR.setConfirm(i);
          }
	}

    void replaceCommon(boolean mode)
    {
	    FR.setReplace(fieldReplace.getText());
	    FR.setFind(fieldFind.getText());
	    FR.setCase(checkCase.getState());
	    FR.setReplaceAll(mode);
	    FR.setReplaceIt(mode); // remplacement requis
    }

	void replaceOne()
	{
        replaceCommon(false);
  //      FR.setIndexToReplace();
        FR.setIndexAtCaret();
        FR.setFoundIt(false);

            setVisible(false);
	    try{ Thread.sleep(250); } catch(InterruptedException ie){}

	    (new ReplaceConfirmDialog(parentFrame, " Replace Confirm", false, FR)).setVisible(true);
	}

	void replaceAll()
	{
        replaceCommon(true);
            setVisible(false);
	    FindReplaceEngine fre = new FindReplaceEngine(FR);
        fre.ReplaceAll();
	}


  // --------- CLAVIER

  public void keyTyped(KeyEvent event) { }
  public void keyReleased(KeyEvent event) { }
  public void keyPressed(KeyEvent event)
   {

     if(event.isControlDown() || event.isAltDown()) return;

     switch(event.getKeyCode())
      {
   	   case KeyEvent.VK_ENTER:
 	         if(checkConfirm.getState() == false)
 	                 replaceAll();
             else  replaceOne();
       	     break;
       case KeyEvent.VK_ESCAPE: setVisible(false);
            break;
       default:
            char c = event.getKeyChar();
            char newc = new Character(c).charValue();
   	        if (c != newc) event.consume();
   	        break;
  	 }
  }

/*
  public void textValueChanged(TextEvent te)
  {

   System.out.println(te.toString());
  }
*/
}
